# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ....core.datetime_utils import serialize_datetime
from .brand_settings import BrandSettings
from .brand_snippets import BrandSnippets

try:
    import pydantic.v1 as pydantic  # type: ignore
except ImportError:
    import pydantic  # type: ignore


class Brand(pydantic.BaseModel):
    created: int = pydantic.Field(
        description="The date/time of when the brand was created. Represented in milliseconds since Unix epoch."
    )
    id: typing.Optional[str] = pydantic.Field(description="Brand Identifier")
    name: str = pydantic.Field(description="Brand name")
    published: int = pydantic.Field(
        description="The date/time of when the brand was published. Represented in milliseconds since Unix epoch."
    )
    settings: BrandSettings
    updated: int = pydantic.Field(
        description="The date/time of when the brand was updated. Represented in milliseconds since Unix epoch."
    )
    snippets: typing.Optional[BrandSnippets]
    version: str = pydantic.Field(description="The version identifier for the brand")

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        json_encoders = {dt.datetime: serialize_datetime}
