# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ....core.datetime_utils import serialize_datetime

try:
    import pydantic.v1 as pydantic  # type: ignore
except ImportError:
    import pydantic  # type: ignore


class InboundBulkMessageV1(pydantic.BaseModel):
    brand: typing.Optional[str] = pydantic.Field(
        description=(
            "A unique identifier that represents the brand that should be used\n" "for rendering the notification.\n"
        )
    )
    data: typing.Optional[typing.Dict[str, typing.Any]] = pydantic.Field(
        description=(
            "JSON that includes any data you want to pass to a message template.\n"
            "The data will populate the corresponding template variables.\n"
        )
    )
    event: typing.Optional[str]
    locale: typing.Optional[typing.Dict[str, typing.Any]]
    override: typing.Optional[typing.Any] = pydantic.Field(
        description=(
            "JSON that is merged into the request sent by Courier to the provider\n"
            "to override properties or to gain access to features in the provider\n"
            "API that are not natively supported by Courier.\n"
        )
    )

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        json_encoders = {dt.datetime: serialize_datetime}
