# This file was auto-generated by Fern from our API Definition.

import enum
import typing

T_Result = typing.TypeVar("T_Result")


class MessageStatus(str, enum.Enum):
    CLICKED = "CLICKED"
    """
    The recipient has clicked on any link in the message at least one time.
    """

    DELIVERED = "DELIVERED"
    """
    The provider successfully delivered the message to the recipient.
    """

    ENQUEUED = "ENQUEUED"
    """
    The request has been received to send a message, is waiting in the work queue.
    """

    OPENED = "OPENED"
    """
    The recipient has opened the message at least one time.
    """

    CANCELED = "CANCELED"
    """
    The message has been canceled such that it will not be delivered.
    """

    SENT = "SENT"
    """
    The message has been accepted by the provider.
    """

    UNDELIVERABLE = "UNDELIVERABLE"
    """
    The message could not be delivered to at least one provider, or the provider could not deliver the message to the recipient. This can happen for multiple reasons: an error, insufficient profile data, invalid notification setup, invalid integration configuration, etc.
    """

    UNMAPPED = "UNMAPPED"
    """
    Could not find a corresponding notification or event for the messages.
    """

    UNROUTABLE = "UNROUTABLE"
    """
    The message could not be routed to any channel or provider. This can happen for multiple reasons: insufficient profile data, invalid notification setup, invalid integration configuration, etc.
    """

    def visit(
        self,
        clicked: typing.Callable[[], T_Result],
        delivered: typing.Callable[[], T_Result],
        enqueued: typing.Callable[[], T_Result],
        opened: typing.Callable[[], T_Result],
        canceled: typing.Callable[[], T_Result],
        sent: typing.Callable[[], T_Result],
        undeliverable: typing.Callable[[], T_Result],
        unmapped: typing.Callable[[], T_Result],
        unroutable: typing.Callable[[], T_Result],
    ) -> T_Result:
        if self is MessageStatus.CLICKED:
            return clicked()
        if self is MessageStatus.DELIVERED:
            return delivered()
        if self is MessageStatus.ENQUEUED:
            return enqueued()
        if self is MessageStatus.OPENED:
            return opened()
        if self is MessageStatus.CANCELED:
            return canceled()
        if self is MessageStatus.SENT:
            return sent()
        if self is MessageStatus.UNDELIVERABLE:
            return undeliverable()
        if self is MessageStatus.UNMAPPED:
            return unmapped()
        if self is MessageStatus.UNROUTABLE:
            return unroutable()
