# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ....core.datetime_utils import serialize_datetime
from .base_message import BaseMessage
from .content import Content
from .message_recipient import MessageRecipient

try:
    import pydantic.v1 as pydantic  # type: ignore
except ImportError:
    import pydantic  # type: ignore


class ContentMessage(BaseMessage):
    """
    The message property has the following primary top-level properties. They define the destination and content of the message.
    Additional advanced configuration fields [are defined below](https://www.courier.com/docs/reference/send/message/#other-message-properties).
    """

    content: Content = pydantic.Field(
        description=(
            "Describes the content of the message in a way that will work for email, push,\n"
            "chat, or any channel. Either this or template must be specified.\n"
        )
    )
    to: MessageRecipient = pydantic.Field(description="The recipient or a list of recipients of the message")

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        allow_population_by_field_name = True
        json_encoders = {dt.datetime: serialize_datetime}
