# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ....core.datetime_utils import serialize_datetime
from .elemental_base_node import ElementalBaseNode
from .i_action_button_style import IActionButtonStyle
from .i_alignment import IAlignment
from .locales import Locales

try:
    import pydantic.v1 as pydantic  # type: ignore
except ImportError:
    import pydantic  # type: ignore


class ElementalActionNode(ElementalBaseNode):
    """
    Allows the user to execute an action. Can be a button or a link.
    """

    content: str = pydantic.Field(description="The text content of the action shown to the user.")
    href: str = pydantic.Field(description="The target URL of the action.")
    action_id: typing.Optional[str] = pydantic.Field(
        description="A unique id used to identify the action when it is executed."
    )
    align: typing.Optional[IAlignment] = pydantic.Field(
        description='The alignment of the action button. Defaults to "center".'
    )
    background_color: typing.Optional[str] = pydantic.Field(description="The background color of the action button.")
    style: typing.Optional[IActionButtonStyle] = pydantic.Field(description="Defaults to `button`.")
    locales: Locales = pydantic.Field(
        description="Region specific content. See [locales docs](https://www.courier.com/docs/platform/content/elemental/locales/) for more details."
    )

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        allow_population_by_field_name = True
        json_encoders = {dt.datetime: serialize_datetime}
