# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ....core.datetime_utils import serialize_datetime
from .elemental_base_node import ElementalBaseNode
from .i_alignment import IAlignment

try:
    import pydantic.v1 as pydantic  # type: ignore
except ImportError:
    import pydantic  # type: ignore


class ElementalImageNode(ElementalBaseNode):
    """
    Used to embed an image into the notification.
    """

    src: str = pydantic.Field(description="The source of the image.")
    href: typing.Optional[str] = pydantic.Field(description="A URL to link to when the image is clicked.")
    align: typing.Optional[IAlignment] = pydantic.Field(description="The alignment of the image.")
    alt_text: typing.Optional[str] = pydantic.Field(alias="altText", description="Alternate text for the image.")
    width: typing.Optional[str] = pydantic.Field(
        description="CSS width properties to apply to the image. For example, 50px"
    )

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        allow_population_by_field_name = True
        json_encoders = {dt.datetime: serialize_datetime}
