# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ....core.datetime_utils import serialize_datetime
from ...commons.types.channel_preference import ChannelPreference
from ...commons.types.preference_status import PreferenceStatus
from ...commons.types.rule import Rule
from .channel_source import ChannelSource

try:
    import pydantic.v1 as pydantic  # type: ignore
except ImportError:
    import pydantic  # type: ignore


class Preference(pydantic.BaseModel):
    status: PreferenceStatus
    rules: typing.Optional[typing.List[Rule]]
    channel_preferences: typing.Optional[typing.List[ChannelPreference]]
    source: typing.Optional[ChannelSource]

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        json_encoders = {dt.datetime: serialize_datetime}
