# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ....core.datetime_utils import serialize_datetime
from .routing_strategy import RoutingStrategy
from .tag import Tag

try:
    import pydantic.v1 as pydantic  # type: ignore
except ImportError:
    import pydantic  # type: ignore


class NotificationTemplates(pydantic.BaseModel):
    created_at: int = pydantic.Field(
        description="A UTC timestamp at which notification was created. This is stored as a millisecond representation of the Unix epoch (the time passed since January 1, 1970)."
    )
    id: str = pydantic.Field(description="A unique identifier associated with the notification.")
    routing: RoutingStrategy = pydantic.Field(description="Routing strategy used by this notification.")
    tags: typing.List[Tag] = pydantic.Field(description="A list of tags attached to the notification.")
    title: str = pydantic.Field(description="The title of the notification.")
    updated_at: int = pydantic.Field(
        description="A UTC timestamp at which notification was updated. This is stored as a millisecond representation of the Unix epoch (the time passed since January 1, 1970)."
    )

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        json_encoders = {dt.datetime: serialize_datetime}
